<?php
/**
* Joomla Community Builder User Plugin: plug_publicmail
* @author Thomas Kampp, www.toolmaster.dk
* @copyright (C) 2008 by Thomas Kampp, www.toolmaster.com
* @license Limited  http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

# Joomla Safety
defined('_JEXEC') or die( 'Restricted access' );

class getPublicMailTab extends cbTabHandler {

	# Constructor
	function getPublicMailTab() {
		$this->cbTabHandler();
	}


	# Create form/text/content and insert in frontend!
	function showForm($visitingUser, $user, $publicmailUseCaptcha, $publicmailTableWidth, $publicmailShowIntro, $publicmailShowAddress, $publicmailUseSubject, $publicmailUseCopy, $publicmailFieldSize, $publicmailFieldMaxLength, $publicmailTextMaxlength, $publicmailTextRows, $publicmailTextCols, $publicmailUseExtra1, $publicmailExtra1Intro, $publicmailUseExtra2, $publicmailExtra2Intro, $publicmailUseExtra3, $publicmailExtra3Intro) {

		# Javascript that checks that form has been filled in
		echo "\n<script language=\"Javascript\">";
		echo "  function validate(){";
		echo "    if ((document.mailForm.mailName.value=='') || (document.mailForm.mailMail.value=='') || (document.mailForm.mailText.value=='')) {";
		echo "      alert(\""._PM_FORM_ALERT."\");";
			echo "		return false;";
		echo "    } else {";
			echo "		return true;";
//		echo "      document.mailForm.action = 'index.php';";
//		echo "      document.mailForm.submit();";
		echo "    }";
		echo "  }";
		echo "</script>\n";

		# Javascript that makes maxlength in textarea work!
		?>
		<script type="text/javascript">
		function ismaxlength(obj){
		var mlength=obj.getAttribute? parseInt(obj.getAttribute("maxlength")) : ""
		if (obj.getAttribute && obj.value.length>mlength)
			obj.value=obj.value.substring(0,mlength)
		}
		</script>
		<?php

		# Start form and insert hidden return values
		$content = "\n<div class='publicmail'>";
		$content .= "<form name='mailForm' action='' method='post' id='publicmail'>\n";
		$content .= "<input type='hidden' name='option' value='com_comprofiler'>";
    	$content .= "<input type='hidden' name='task' value='userProfile'>"; // Hvilken func i main-switch der skal loades om lidt!
    	$content .= "<input type='hidden' name='user' value='$user->id'>"; // Her fortælles hvilken type der skal gemmes

		# Show the form content
		$content .= "\n<table cellpadding='1' cellspacing='0' border='0' width='".$publicmailTableWidth."' id='publicmail1'><tr><td align='left'>";
		$content .= $publicmailShowIntro."<br/>";
		if (($publicmailShowAddress==2 AND $visitingUser->id<>0) OR $publicmailShowAddress==1) { // registred and logged in OR all
			$email = JHTML::_( 'email.cloak', $user->email );
			$content .= _PM_FORM_EMAIL." ".$email;
		}

			$content .= "</td></tr><tr><td align='left' valign='top'>";
			$content .= "\n<table cellpadding='0' cellspacing='0' border='0' width='100%' id='publicmail2'><tr><td align='left' width='35%'>";
			$content .= _PM_FORM_NAME.": </td><td><input type='text' name='mailName' class='inputbox' value='".$visitingUser->name."' size='".$publicmailFieldSize."' maxlength='50'>";
			$content .= "</td></tr><tr><td align='left' width='35%'>";
			$content .= _PM_FORM_MAIL.": </td><td><input type='text' name='mailMail' class='inputbox' value='".$visitingUser->email."' size='".$publicmailFieldSize."' maxlength='50'>";
			if ($publicmailUseSubject) {
			$content .= "</td></tr><tr><td align='left' width='35%'>";
			$content .= _PM_FORM_SUBJECT.": </td><td><input type='text' name='mailSubject' class='inputbox' size='".$publicmailFieldSize."' maxlength='".$publicmailFieldMaxLength."'>";
			}
			if ($publicmailUseExtra1) {
			$content .= "</td></tr><tr><td align='left' width='35%'>";
			$content .= $publicmailExtra1Intro.": </td><td><input type='text' name='mailExtra1' class='inputbox' size='".$publicmailFieldSize."' maxlength='".$publicmailFieldMaxLength."'>";
			}
			if ($publicmailUseExtra2) {
			$content .= "</td></tr><tr><td align='left' width='35%'>";
			$content .= $publicmailExtra2Intro.": </td><td><input type='text' name='mailExtra2' class='inputbox' size='".$publicmailFieldSize."' maxlength='".$publicmailFieldMaxLength."'>";
			}
			if ($publicmailUseExtra3) {
			$content .= "</td></tr><tr><td align='left' width='35%'>";
			$content .= $publicmailExtra3Intro.": </td><td><input type='text' name='mailExtra3' class='inputbox' size='".$publicmailFieldSize."' maxlength='".$publicmailFieldMaxLength."'>";
			}
			$content .= "</td></tr></table>";
			$content .= "\n<table cellpadding='0' cellspacing='0' border='0' width='100%' id='publicmail3'><tr><td align='left'>";
			$content .= _PM_FORM_MESSAGE.": <br/><textarea wrap='virtual' name='mailText' class='inputbox' onkeyup='return ismaxlength(this)' maxlength='".$publicmailTextMaxlength."' rows='".$publicmailTextRows."' cols='".$publicmailTextCols."'></textarea>";
			if ($publicmailUseCopy) {
			$content .= "</td></tr><tr><td align='left'>";
			$content .= "<input type='checkbox' name='sendCopy' class='inputbox' value='sendCopy' /> "._PM_FORM_COPY;
			}
			$content .= "</td></tr></table>\n";

		### CAPTCHA - start ###
		if ( ($publicmailUseCaptcha==2) || ( ($publicmailUseCaptcha==1) && ($curruser===null) ) ) {
			global $_PLUGINS;

			$_PLUGINS->loadPluginGroup('user');
			$pluginsResults = $_PLUGINS->trigger( 'onGetCaptchaHtmlElements', array( true ) ); // onCheckCaptchaHtmlElements
			if ( implode( $pluginsResults ) != '' ) {
				$content .= '' . implode( '', $pluginsResults ) . '';
			}
		}
		### CAPTCHA - end ###

		$content .= "</td></tr><tr><td align='left'>";
		$content .= "<input type='submit' value='"._PM_FORM_BUTTON."' class='btn btn-primary' onClick='validate()'>";
		$content .= "</td></tr></table>";
		$content .= "</form>";
		$content .= "</div>\n";

		return $content;
	}


	# Is the email a real email?
	function is_email($email){
		$emailstatus=false;
		if(preg_match("/[\w\.\-]+@\w+[\w\.\-]*?\.\w{1,4}/", $email)) {
		  $emailstatus=true;
		}
		return $emailstatus;
	}


	# Make the input save-safe
	function makeTextSafe($text) {
		$text = strip_tags($text);
		$text = mysql_escape_string($text);
		return $text;
	}


	# Test is user IP is a blocked IP
	function isUserIpBlocked($userIP, $publicmailBlockedIPs) {

		$result = false;

		$pieces = explode(",", $publicmailBlockedIPs);
		foreach ($pieces as $entry) {
			if ($entry==$userIP) { $result = true; } // User has blocked IP
		}

		return $result;
	}


	# Add/log sent mail to database
	function addMailToDB($visitingUser, $user, $isUser, $name, $mail, $subj, $ext1, $ext2, $ext3, $text) {

		# Find all variables for database entry and make them safe
		if ($isUser) { $senderid = $visitingUser->id; } else { $senderid = _PM_LOG_USER_IS_UNKNOWN; }// Find user id
		$senderip = getenv('REMOTE_ADDR'); // Find user IP. Also  $_SERVER['REMOTE_ADDR'];  can be used!
		$maildate = date("y/m/d g:i:s"); // Find current date and time acoording to the server

		# Inserting into database
		$db =& JFactory::getDBO();
		$query = "INSERT INTO #__comprofiler_plug_publicmail SET senderid='$senderid', senderip='$senderip', sendername='$name', sendermail='$mail', recieverid='$user->id', recieverusername='$user->username', maildate='$maildate', mailsubject='$subj', mailextra1='$ext1', mailextra2='$ext2', mailextra3='$ext3', mailtext='$text'";
		$db->setQuery($query);
		$db->query();

	    return;
	}


	# Send the acutal email with the content created
	// @mail($reciever,$subject,$message,"From: $mail");
	// http://docs.joomla.org/How_to_send_email_from_components
	function sendMail($recipientName, $recipientEmail, $senderName, $senderEmail, $subject, $message, $attachment) {

		# Clean message
		$message = str_replace('\r\n', "<br>", $message); // Replace Windows breaks \r\n with <br/>    - has a problem with the / in <br>, therefore left out!
		$message = str_replace('\n', "<br>", $message); // Replace Linux/Unix breaks \n with <br/>     - has a problem with the / in <br>, therefore left out!
		//$message = preg_replace('~\r\n?~', '\n', $message); // Convert Windows line break \r\n to Unix line breaks \n
		$message = nl2br($message); // Replace Unix linebreaks \n with <br/>     - Is allready done, but why not just make sure!
		$message = stripslashes($message); // Remove all /
		$message = wordwrap($message, 70); // Just to be safe that SMTP-send works
		$subject = stripslashes($subject);

		# Get single param
		$params = $this->params;
		$publicmailSender = $params->get('publicmailSender', "0");

		# Create mail
		$mail =& JFactory::getMailer();
		if ($publicmailSender) { // If activated the sender is the site and not the contacting user, and the "reply to" address is set to the user who filled in the form
			# Find info from Joomla configuration
			$mainframe = JFactory::getApplication();
			$frommail = $mainframe->getCfg('mailfrom');
			$fromname = $mainframe->getCfg('fromname');

			$mail->setSender( array($frommail, $fromname) );
			$mail->addReplyTo( array($senderEmail, $senderName ) );
		} else {
			$mail->setSender( array($senderEmail, $senderName) );
		}
		$mail->addRecipient( $recipientEmail );
		$mail->addAttachment( $attachment );
		$mail->IsHTML(true);
		$mail->setSubject( $subject );
		$mail->setBody( $message );

		# Test
		//echo "<br/><br/>SEND MAIL FUNCTION:<br/>recipientName: ".$recipientName."<br/>recipientEmail: ".$recipientEmail."<br/>senderName: ".$senderName."<br/>senderEmail: ".$senderEmail."<br/>subject: ".$subject."<br/>message: ".$message."<br/>"; print_r($mail);

		# Send mail and return
		if ($mail->send()===true) { return true; } else { return false; } // Use print_r($mail->send()); to view errors from Joomla mail send function
	}


	# Mail reciever
	function mailReciever($user, $publicmailBcc, $publicmailBccEmail, $publicmailBccPrefix, $publicmailExtra1Intro, $publicmailExtra2Intro, $publicmailExtra3Intro, $name, $mail, $subj, $ext1, $ext2, $ext3, $text) {

		# Get Live Path
		$live_site = JURI::base( false );

		# Compose message
		$message = _PM_MAIL_GREETING." ".$user->user."<br/><br/>"._PM_RECIEVER_MESSAGE1." ".$live_site." "._PM_RECIEVER_MESSAGE2." ".$name." (".$mail."): <br/>";
		if ($ext1) { $message .= "<br/><b>".$publicmailExtra1Intro.":</b> ".$ext1."<br/>"; }
		if ($ext2) { $message .= "<br/><b>".$publicmailExtra2Intro.":</b> ".$ext2."<br/>"; }
		if ($ext3) { $message .= "<br/><b>".$publicmailExtra3Intro.":</b> ".$ext3."<br/>"; }
		$message .= "<br/>".$text."<br/><br/><br/><br/>"._PM_RECIEVER_FOOTER;

		# Send the mail!
		$this->sendMail($recipientName=$user->name, $recipientEmail=$user->email, $senderName=$mail, $senderEmail=$name, $subject=$subj, $message, $attachment);

		# BCC work around because of an Joomla bug (see 6 lines above) prevents it from working
		if ($publicmailBcc) { // Reload function but set BCC to null so it does not enter a infinite loop, and changed reciever
			$bcc->username = $user->username;
			$bcc->email = $publicmailBccEmail;
			if ($publicmailBccPrefix) { $subj = $publicmailBccPrefix." ".$subj; }
			$this->mailReciever($bcc, $publicmailBcc=0, $publicmailBccEmail, $publicmailBccPrefix, $publicmailExtra1Intro, $publicmailExtra2Intro, $publicmailExtra3Intro, $name, $mail, $subj, $ext1, $ext2, $ext3, $text);
		}

    	return;
	}


	# Mail copy
	function mailCopy($frommail, $fromname, $user, $publicmailExtra1Intro, $publicmailExtra2Intro, $publicmailExtra3Intro, $name, $mail, $subj, $ext1, $ext2, $ext3, $text) {

		# Get Live Path
		$live_site = JURI::base( false );

		# Compose message
		$subject = _PM_COPY_SUBJECT." ".$subj;
		$message = _PM_MAIL_GREETING." ".$name."<br/><br/>"._PM_COPY_MESSAGE1." ".$user->name." "._PM_COPY_MESSAGE2." ".$live_site."<br/>";
		if ($ext1) { $message .= "<br/><b>".$publicmailExtra1Intro.":</b> ".$ext1."<br/>"; }
		if ($ext2) { $message .= "<br/><b>".$publicmailExtra2Intro.":</b> ".$ext2."<br/>"; }
		if ($ext3) { $message .= "<br/><b>".$publicmailExtra3Intro.":</b> ".$ext3."<br/>"; }
		$message .= "<br/>".$text."<br/><br/><br/><br/>"._PM_MAIL_FOOTER;

		# Send the mail!
		$this->sendMail($recipientName=$name, $recipientEmail=$mail, $senderName=$fromname, $senderEmail=$frommail, $subject, $message, $attachment);

    	return;
	}


	# Mail sender ("thank you")
	function mailSenderThanks($frommail, $fromname, $name, $mail) {

		# Get Live Path
		$live_site = JURI::base( false );

		# Compose message
		$subject = _PM_THANKU_SUBJECT." ".$live_site;
		$message = _PM_MAIL_GREETING." ".$name."<br/><br/>"._PM_THANKU_THANKS." ".$live_site."<br/><br/>"._PM_MAIL_FOOTER;

		# Send the mail!
		$this->sendMail($recipientName=$name, $recipientEmail=$mail, $senderName=$fromname, $senderEmail=$frommail, $subject, $message, $attachment);

	    return;
	}


	# Send mails and log
	function sendMails($visitingUser, $user, $isUser, $publicmailBcc, $publicmailBccEmail, $publicmailBccPrefix, $publicmailPrefix, $publicmailLogMails, $publicmailThankSender, $publicmailExtra1Intro, $publicmailExtra2Intro, $publicmailExtra3Intro, $name, $mail, $subj, $ext1, $ext2, $ext3, $text, $copy) {

		# Find info from Joomla configuration
		$mainframe = JFactory::getApplication();
		$frommail = $mainframe->getCfg('mailfrom');
		$fromname = $mainframe->getCfg('fromname');
		
		# Create email subject - add prefix if any
		if ($publicmailPrefix) { $subj  = $publicmailPrefix." ".$subj; }
		
		# Send mail
		$this->mailReciever($user, $publicmailBcc, $publicmailBccEmail, $publicmailBccPrefix, $publicmailExtra1Intro, $publicmailExtra2Intro, $publicmailExtra3Intro, $name, $mail, $subj, $ext1, $ext2, $ext3, $text);
		# Send copy
		if ($copy=="sendCopy") { $this->mailCopy($frommail, $fromname, $user, $publicmailExtra1Intro, $publicmailExtra2Intro, $publicmailExtra3Intro, $name, $mail, $subj, $ext1, $ext2, $ext3, $text); }
		# Send thanks
		if ($publicmailThankSender) { $this->mailSenderThanks($frommail, $fromname, $name, $mail); }
		# Log mail in DB
		if ($publicmailLogMails) { $this->addMailToDB($visitingUser, $user, $isUser, $name, $mail, $subj, $ext1, $ext2, $ext3, $text); }

		$mainframe->redirect( JRoute::_('index.php?option=com_comprofiler&task=userProfile&user='.$user->id) , _PM_MAIL_HAS_BEEN_SENT ); 
	}


	# Main funtion!
	function getDisplayTab($tab, $user) { // $user = the visited profile
		
		# Load mainframe
		$mainframe = JFactory::getApplication();

		# Load plugin language
		$language = JFactory::getLanguage();
		$tag = $language->getTag();
		if (file_exists(JPATH_COMPONENT."/plugin/user/plug_cbpublicmail/languages/".$tag.".php")) {
			include(JPATH_COMPONENT."/plugin/user/plug_cbpublicmail/languages/".$tag.".php");
		} else {
			include(JPATH_COMPONENT."/plugin/user/plug_cbpublicmail/languages/en-GB.php");
		}

		# Load parameters
		$params=$this->params;
		$publicmailShowForm 	= $params->get('publicmailShowForm', "0");
		$publicmailUseCaptcha 	= $params->get('publicmailUseCaptcha', "0");
		$publicmailTableWidth 	= $params->get('publicmailTableWidth', "100%");
		$publicmailShowIntro 	= $params->get('publicmailShowIntro', "If you want to contact this person, you may use this email-form:");
		$publicmailShowAddress 	= $params->get('publicmailShowAddress', "0");
		$publicmailOwnerVisit 	= $params->get('publicmailOwnerVisit', "0");
		$publicmailBcc 			= $params->get('publicmailBcc', "0");
		$publicmailBccEmail		= $params->get('publicmailBccEmail', "");
		$publicmailBccPrefix	= $params->get('publicmailBccPrefix', "Public Mail:");
		$publicmailPrefix		= $params->get('publicmailPrefix', "Site:");
		$publicmailThankSender  = $params->get('publicmailThankSender', "0");
		$publicmailLogMails 	= $params->get('publicmailLogMails', "0");
		$publicmailUseCopy 		= $params->get('publicmailUseCopy', "0");
		$publicmailUseSubject 	= $params->get('publicmailUseSubject', "1");
		$publicmailFieldSize 	= $params->get('publicmailFieldSize', "23");
		$publicmailFieldMaxLength= $params->get('publicmailFieldMaxLength', "60");
		$publicmailTextMaxlength= $params->get('publicmailTextMaxlength', "500");
		$publicmailTextRows 	= $params->get('publicmailTextRows', "5");
		$publicmailTextCols 	= $params->get('publicmailTextCols', "40");
		$publicmailUseExtra1 	= $params->get('publicmailUseExtra1', "0");
		$publicmailExtra1Intro 	= $params->get('publicmailExtra1Intro', "Contact number");
		$publicmailUseExtra2 	= $params->get('publicmailUseExtra2', "0");
		$publicmailExtra2Intro 	= $params->get('publicmailExtra2Intro', "MSN address");
		$publicmailUseExtra3 	= $params->get('publicmailUseExtra3', "0");
		$publicmailExtra3Intro 	= $params->get('publicmailExtra3Intro', "Company");
		$publicmailRestrict 	= $params->get('publicmailRestrict', "0");
		$publicmailRestrictUsers= $params->get('publicmailRestrictUsers', "");
		$publicmailBlockedIPs	= $params->get('publicmailBlockedIPs', "");

		# Get user instance
		$visitingUser =& JFactory::getUser();
		if ($visitingUser->id<>"") { $isUser = true; } else { $isUser = false; }
		$showPublicMail = 0;

		# Should Public Mail be shown to users - CHECK?
		if ($publicmailRestrict) {
			# Split so they can be compared
			$pieces = explode(",", $publicmailRestrictUsers);
			foreach ($pieces as $entry) {
				# Is profile/user ID from Public Mail the current profile shown?
				if ($entry==$user->id) { $showPublicMail = 1; }
			}
		} // else { $showPublicMail = 1; } // show to all - off

		# Check if Public Mail should be shown on profile
		if (!$publicmailRestrict OR ($publicmailRestrict==1 AND !$showPublicMail) OR ($publicmailRestrict==2 AND $showPublicMail)) {

			# Variables to check if form has been filled in and email(s) needs to be sent
			$name = JRequest::getString( 'mailName' );
			$mail = JRequest::getString( 'mailMail' );
			$subj = JRequest::getString( 'mailSubject' );
			$ext1 = JRequest::getString( 'mailExtra1' );
			$ext2 = JRequest::getString( 'mailExtra2' );
			$ext3 = JRequest::getString( 'mailExtra3' );
			$text = JRequest::getVar( 'mailText' );
			$copy = JRequest::getVar( 'sendCopy' );

			# avoid error in frontend
			$content = "";

			# Show/load content/plugin
			if ($name AND $this->is_email($mail) AND $text) { // If an email should be sent

				### CAPTCHA - start ###
				$resultError = null;
				if ( ( $publicmailUseCaptcha == 2 ) || ( ( $publicmailUseCaptcha == 1 ) && ( $curruser === null ) ) ) {
					global $_PLUGINS;

					$_PLUGINS->loadPluginGroup('user');
					$pluginsResults = $_PLUGINS->trigger( 'onCheckCaptchaHtmlElements', array() );
					if($_PLUGINS->is_errors()) { $resultError = $_PLUGINS->getErrorMSG(); }
				}
				if ( $resultError === null ) {
					# APPROVED
					$name = $this->makeTextSafe($name); $mail = $this->makeTextSafe($mail); $subj = $this->makeTextSafe($subj); $ext1 = $this->makeTextSafe($ext1); $ext2 = $this->makeTextSafe($ext2); $ext3 = $this->makeTextSafe($ext3); $text = $this->makeTextSafe($text);
					$this->sendMails($visitingUser, $user, $isUser, $publicmailBcc, $publicmailBccEmail, $publicmailBccPrefix, $publicmailPrefix, $publicmailLogMails, $publicmailThankSender, $publicmailExtra1Intro, $publicmailExtra2Intro, $publicmailExtra3Intro, $name, $mail, $subj, $ext1, $ext2, $ext3, $text, $copy);
				} else {
					# NOT APPROVED
					echo "<script> alert('"._PM_FORM_CAPTCHA_ERROR."'); window.history.go(-1); </script>\n";
				}
				### CAPTCHA - end ###

			} else if ($visitingUser->id==$user->id AND $publicmailOwnerVisit!="2") { // If own profile is visited
				if ($publicmailOwnerVisit=="1") { $content = _PM_VISITING_OWN_PROFILE; }

			} else if ($this->isUserIpBlocked($userIP = getenv('REMOTE_ADDR'), $publicmailBlockedIPs)) { // Is the sender IP is blocked
				$content = _PM_IP_BLOCKED;

			} else if (($publicmailShowForm=="2" AND !$isUser) OR ($publicmailShowForm=="1" AND $isUser) OR $publicmailShowForm=="0") { // Show mail-form to "All Unregistred users/visitors!" or "All registred users!" or "All users/users!"
				$content = $this->showForm($visitingUser, $user, $publicmailUseCaptcha, $publicmailTableWidth, $publicmailShowIntro, $publicmailShowAddress, $publicmailUseSubject, $publicmailUseCopy, $publicmailFieldSize, $publicmailFieldMaxLength, $publicmailTextMaxlength, $publicmailTextRows, $publicmailTextCols, $publicmailUseExtra1, $publicmailExtra1Intro, $publicmailUseExtra2, $publicmailExtra2Intro, $publicmailUseExtra3, $publicmailExtra3Intro);
			}

		} // end "Check if Public Mail should be shown on profile"

		return $content;
	} // end getDisplayTab
}	// end class getPublicMailTab.
?>
